--[[
	              ----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----


                                                  #          ####     #       #     ####
                                                  #        ##    ##   ##      #   ##    ##
                                                  #       ##      ##  # #     #  ##
                                                  #       #        #  #  #    #  #
                                                  #       #        #  #   #   #  #
                                                  #       #        #  #    #  #  #     ###
                                                  #       ##      ##  #     # #  ##      #
                                                  #        ##    ##   #      ##   ##    ##
                                                  #######    ####     #       #     ####


                      #########    ####     #######       ####       ####     #########  #########  ########  #       #
                      #          ##    ##   #     ##    ##    ##   ##    ##       #          #      #         ##      #
                      #         ##      ##  #       #  ##         ##      ##      #          #      #         # #     #
                      #         #        #  #     ##   #          #        #      #          #      #         #  #    #
                      #######   #        #  #######    #          #        #      #          #      ########  #   #   #
                      #         #        #  #   #      #     ###  #        #      #          #      #         #    #  #
                      #         ##      ##  #    #     ##      #  ##      ##      #          #      #         #     # #
                      #          ##    ##   #     #     ##    ##   ##    ##       #          #      #         #      ##
                      #            ####     #      #      ####       ####         #          #      ########  #       #


                    #       #  #  #######    #######       ####        ####    #######   #         # #######    #       #
                    #       #  #  #     ##   #     ##    ##    ##    ##    ##  #     ##   #       #  #     ##   #       #
                    #       #  #  #       #  #       #  ##      ##  ##         #       #   #     #   #       #  #       #
                    #       #  #  #     ##   #     ##   #        #  #          #     ##     #   #    #     ##   #       #
                    #########  #  #######    #######    #        #  #          #######       # #     #######    #########
                    #       #  #  #          #          #        #  #     ###  #   #          #      #          #       #
                    #       #  #  #          #          ##      ##  ##      #  #    #         #      #          #       #
                    #       #  #  #          #           ##    ##    ##    ##  #     #        #      #          #       #
                    #       #  #  #          #             ####        ####    #      #       #      #          #       #


                                                       --==  BATTLE FOR AZEROTH  ==--


                    ----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----(||)----o----


                                                    ----o----(||)----oo----(||)----o----

                                                            v2.02 - 3rd July 2019
                                                    Copyright (C) Taraezor / Chris Birch

                                                    ----o----(||)----oo----(||)----o----

]]

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Localisations and Local Data
--		============================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local addonName, L = ...
local addonTitle = addonName

local cos = math.cos
local find = string.find
local format = string.format
local gmatch = string.gmatch
local gsub = string.gsub
local lower = string.lower
local random = random
local sin = math.sin
local sqrt = math.sqrt
local sub = string.sub
local tonumber = tonumber
local tostring = tostring

local CreateFrame = CreateFrame
local EnumerateFrames = EnumerateFrames
local GameTooltip = GameTooltip
local GetBestMapForUnit = C_Map and C_Map.GetBestMapForUnit or nil
local GetCursorPosition = GetCursorPosition
local GetCVar = GetCVar
local GetPlayerFacing = GetPlayerFacing
local GetPlayerMapPosition = C_Map and C_Map.GetPlayerMapPosition or GetPlayerMapPosition
local GetTime = GetTime
local IsControlKeyDown = IsControlKeyDown
local IsIndoors = IsIndoors
local IsShiftKeyDown = IsShiftKeyDown
local UIDropDownMenu_AddButton = UIDropDownMenu_AddButton
local UIDropDownMenu_AddSeparator = UIDropDownMenu_AddSeparator
local UIDropDownMenu_CreateInfo = UIDropDownMenu_CreateInfo
local UIDropDownMenu_InitializeHelper = UIDropDownMenu_InitializeHelper
local WorldMapTooltip = WorldMapTooltip

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Colour Printing - Pink-Purple Theme
--		===============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local pc_colour_Prefix		= "\124cFFCA64EF"
local pc_colour_Highlight	= "\124cFFE641EF"
local pc_colour_PlainText	= "\124cFFA165F0"

local function printPC( message )
	if message then
		DEFAULT_CHAT_FRAME:AddMessage( pc_colour_Prefix.. addonTitle.. ": ".. pc_colour_PlainText.. message.. "\124r" )
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Pin Textures
--		============
--
--------------------------------------------------------------------------------------------------------------------------------------------

textures = {
	E = {
		["1"] = "Interface\\TargetingFrame\\UI-PhasingIcon", ["2"] = "Interface\\Store\\Category-icon-pets",
		["3"] = "Interface\\Store\\Category-icon-featured", ["4"] = "Interface\\PlayerFrame\\MonkDarkPower",
		["5"] = "Interface\\PlayerFrame\\MonkLightPower", ["6"] = "Interface\\Common\\Friendship-ManaOrb",		
		["7"] = "Interface\\Common\\Indicator-Gray", ["8"] = "Interface\\HelpFrame\\HelpIcon-CharacterStuck",		
		["9"] = "Interface\\PlayerFrame\\UI-PlayerFrame-DeathKnight-Frost", ["10"] = "Interface\\TargetingFrame\\PetBadge-Magical",	
		["11"] = "Interface\\Common\\Indicator-Red", ["12"] = "Interface\\Common\\Indicator-Yellow",
		["13"] = "Interface\\Common\\Indicator-Green", ["14"] = "Interface\\Vehicles\\UI-Vehicles-Raid-Icon",
		
		num = 14,
		
		coords = { ["1"] = { 0, 1, 0, 1}, ["2"] = { 0, 1, 0, 1}, ["3"] = { 0, 1, 0, 1}, ["4"] = { 0, 1, 0, 1}, ["5"] = { 0, 1, 0, 1}, 
				["6"] = { 0, 1, 0, 1}, ["7"] = { 0, 1, 0, 1}, ["8"] = { 0, 1, 0, 1}, ["9"] = { 0, 1, 0, 1}, ["10"] = { 0, 1, 0, 1}, 
				["11"] = { 0, 1, 0, 1}, ["12"] = { 0, 1, 0, 1}, ["13"] = { 0, 1, 0, 1}, ["14"] = { 0, 1, 0, 1}, },

		-- I should also have an X,Y offset due to scaling adjustments and a texture might not have the same origin placement
		size = { ["1"] = 0.95, ["2"] = 1.2, ["3"] = 1.2, ["4"] = 0.85, ["5"] = 0.85, ["6"] = 0.95, ["7"] = 0.83, ["8"] = 0.93, ["9"] = 0.62,
				["10"] = 0.73, ["11"] = 0.83, ["12"] = 0.83, ["13"] = 0.83, ["14"] = 0.67, },
				
		name = { ["1"] = L["Phasing"], ["2"] = L["Raptor egg"], ["3"] = L["Stars"], ["4"] = L["Purple"], ["5"] = L["White"], 
				["6"] = L["Mana Orb"], ["7"] = L["Gray"], ["8"] = L["Cogwheel"], ["9"] = L["Frost"], ["10"] = L["Diamond"], 
				["11"] = L["Red"], ["12"] = L["Yellow"], ["13"] = L["Green"], ["14"] = L["Screw"], }, },

	S = {
		["1"] = "Interface\\Common\\RingBorder", ["2"] = "Interface\\PetBattles\\DeadPetIcon",
		["3"] = "Interface\\Glues\\CharacterSelect\\CharacterUndelete", ["4"] = "Interface\\RaidFrame\\UI-RaidFrame-Threat", 
		["5"] = "Interface\\Challenges\\Challenges-Copper", ["6"] = "Interface\\PlayerFrame\\DeathKnight-Energize-Blood", 
		["7"] = "Interface\\PlayerFrame\\DeathKnight-Energize-Frost", ["8"] = "Interface\\PlayerFrame\\DeathKnight-Energize-Unholy", 
		
		num = 8,
		
		coords = { ["1"] = { 0, 1, 0, 1}, ["2"] = { 0, 1, 0, 1}, ["3"] = { 0, 1, 0, 1}, ["4"] = { 0, 1, 0, 1}, ["5"] = { 0, 1, 0, 1}, 
				["6"] = { 0, 1, 0, 1}, ["7"] = { 0, 1, 0, 1}, ["8"] = { 0, 1, 0, 1}, },

		-- I should also have an X,Y offset due to scaling adjustments and a texture might not have the same origin placement
		size = { ["1"] = 0.58, ["2"] = 0.68, ["3"] = 1.15, ["4"] = 0.65, ["5"] = 0.65, ["6"] = 0.77, ["7"] = 0.77, ["8"] = 0.77, },
				
		name = { ["1"] = L["Gold Ring"], ["2"] = L["Red Cross"], ["3"] = L["Undo"], ["4"] = L["White Diamond"], ["5"] = L["Copper Diamond"], 
				["6"] = L["Red Ring"], ["7"] = L["Blue Ring"], ["8"] = L["Green Ring"], }, }, }
								
--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Locations
--		=========
--
-- This is without a doubt the most comprehensively organised and annotated list of locations. And accurate to boot!
--
--------------------------------------------------------------------------------------------------------------------------------------------

local tips = {
		E = {
			["1"] = { ["x"] = 29.84, ["y"] = 35.85, ["tip"] = L["Southern side of the base of the\nlargest of two whithered trees"] },
			["2"] = { ["x"] = 29.86, ["y"] = 26.57, ["tip"] = L["On rocks at the south west corner\nof the island, just above the water-"..
																"\nline. Accessible via the water"] },
			["3"] = { ["x"] = 34.92, ["y"] = 17.14, ["tip"] = L["Western side of ruined structure,\nadjacent to overhanging foliage\n"..
																"and close to the shoreline."] },
			["4"] = { ["x"] = 35.59, ["y"] = 37.80, ["tip"] = L["Western side of the tree, near\na rocky ledge to the south\nand a path "..
																"to the north"] },
-- need to finalise this one in or out?																
			["5"] = { ["x"] = 36.00, ["y"] = 36.00, ["author"] = true, ["tip"] = L["On the cliff edge. Likely, but\nnot verified by the author"] },
			["6"] = { ["x"] = 36.04, ["y"] = 23.02, ["tip"] = L["Nestled between two trees"] },
			["7"] = { ["x"] = 36.55, ["y"] = 12.18, ["tip"] = L["On a rocky rise, north of a large\ntent, clearly visible from afar"] }, 
			["8"] = { ["x"] = 37.05, ["y"] = 21.61, ["tip"] = L["Close to the stonework of the\nTimeworn Strand, north-east\nof a tree"] },
			["9"] = { ["x"] = 37.52, ["y"] = 32.92, ["tip"] = L["In the grass between the tree and the\nstair-wall, at the foot of the stairs"] },
			["10"] = { ["x"] = 38.69, ["y"] = 09.31, ["tip"] = L["West of the Challiane's Terrace Flight\nMaster, past the pond, one "..
																"quarter\nof the way towards the cliff edge"] },
			["11"] = { ["x"] = 40.27, ["y"] = 32.82, ["tip"] = L["Northern side of the tree\nat the foot of a rocky rise"] },
			["12"] = { ["x"] = 40.48, ["y"] = 37.54, ["tip"] = L["Southern side of the tree,\nsurrounded by broken stone works"] },
			["13"] = { ["x"] = 40.70, ["y"] = 35.87, ["tip"] = L["In the bushes on the south\nside of the tree. Easily missed"] },
			["14"] = { ["x"] = 42.22, ["y"] = 08.35, ["tip"] = L["On a landing a little way down a cliff.\nVisibility might be affected by"..
																" quest phasing"] },
			["15"] = { ["x"] = 43.00, ["y"] = 28.87, ["tip"] = L["Between a large rock to the south-\nwest and a thin tree and a much \n"..
																"larger tree to the north-east. Just\nyards from a sheer drop to a lake"] },
			["16"] = { ["x"] = 44.06, ["y"] = 59.87, ["tip"] = L["On a rock with a shipwreck to the north.\nThe shipwreck has interior lights"] },
			["17"] = { ["x"] = 45.04, ["y"] = 53.49, ["tip"] = L["On a broken beam inside a partial shipwreck,\nbeneath a huge overhanging rock"] },   
			["18"] = { ["x"] = 45.42, ["y"] = 45.37, ["tip"] = L["On the south-west side of the tree"] },
			["19"] = { ["x"] = 45.54, ["y"] = 17.27, ["tip"] = L["On the southern bank of a lake, at the\njunction where it drains into a river"] },
			["20"] = { ["x"] = 46.58, ["y"] = 53.60, ["tip"] = L["Atop three small flat rocks and\nringed by rocks on almost all sides"] },
			["21"] = { ["x"] = 46.61, ["y"] = 08.45, ["tip"] = L["South west side of a large tree,\nequidistant to a large rock"] },
			["22"] = { ["x"] = 46.70, ["y"] = 17.68, ["tip"] = L["Centred on a gently sloping lower\nsection of a much steeper drop\n"..
																"down to a river to the north"] },
			["23"] = { ["x"] = 46.97, ["y"] = 49.03, ["tip"] = L["South of a tree, surrounded by rocks.\nA top-most and small grassy area"] },
			["24"] = { ["x"] = 47.06, ["y"] = 25.86, ["tip"] = L["Close to a tree to its south, with\na pulsing beacon to its north"] },
			["25"] = { ["x"] = 47.14, ["y"] = 33.18, ["tip"] = L["On the grass above the south bank of\nthe river. Very safe area free "..
																"of hostiles"] },
			["26"] = { ["x"] = 47.25, ["y"] = 61.93, ["tip"] = L["Nestled in the grass on a rocking slope.\n30 yards due south of a Cave Skrog"] },
			["27"] = { ["x"] = 48.47, ["y"] = 48.12, ["tip"] = L["Nestled within the foliage,\nsurrounded by rocks"] }, 
			["28"] = { ["x"] = 48.85, ["y"] = 45.61, ["tip"] = L["On a rock at the water's edge"] },  
			["29"] = { ["x"] = 49.20, ["y"] = 24.24, ["tip"] = L["About 15 yards south of a Spirit\nHealer, flanked by two large trees"] },
			["30"] = { ["x"] = 49.27, ["y"] = 57.99, ["tip"] = L["On the western side\nof the broken pillar"] }, 
			["31"] = { ["x"] = 49.31, ["y"] = 50.53, ["tip"] = L["Behind the sleeping giant,\nequidistant between two foating planks.\n"..
																"Possible to obtain without waking the giant"] },
			["32"] = { ["x"] = 49.33, ["y"] = 31.54, ["tip"] = L["Two adjoining rocks lay to the north and north-\neast. Concealed by "..
																"adjacent bushes to the south"] },
			["33"] = { ["x"] = 49.45, ["y"] = 27.66, ["tip"] = L["A mushroom adorned tree lays to the north-west.\nA tree with a four-way "..
																"split trunk is to the north-\neast. A massive tree is to the south. Well hidden!"] },
			["34"] = { ["x"] = 49.79, ["y"] = 53.94, ["tip"] = L["Nestled in the bushes immediately\nwest of the waterfall's small lake"] },
			["35"] = { ["x"] = 50.08, ["y"] = 33.13, ["tip"] = L["On a flat rise, abutting a cliff face (with\nsea-shell adornments) "..
																"to the north-\nwest. A murloc platform is north-east"] },
			["36"] = { ["x"] = 50.51, ["y"] = 16.43, ["tip"] = L["At the foot of a steep rocky rise to the\nsouth. Trees lay to the east and north"] },
			["37"] = { ["x"] = 51.31, ["y"] = 65.15, ["tip"] = L["In between two large wooden\npylons. Visible from the south"] },

			["38"] = { ["x"] = 51.38, ["y"] = 37.59, ["tip"] = L["At the bottom of El'dranil Shallows\nlake. Between a red/purple "..
																"starfish\nto the west, and a rocky rise"] },
			["39"] = { ["x"] = 52.16, ["y"] = 31.67, ["tip"] = L["West of a small rock at the side of a river,\nwith a spirit healer 7 "..
																"yards to the south"] },
			["40"] = { ["x"] = 52.28, ["y"] = 25.04, ["tip"] = L["On the north side of a thin tree, and\nbutting a huge tree to the north-west"] }, 
			["41"] = { ["x"] = 52.41, ["y"] = 13.46, ["tip"] = L["Midway between a tree to the south-west\nand a circular cairn to the north east"] },
			["42"] = { ["x"] = 52.67, ["y"] = 57.96, ["tip"] = L["On the side of the hill. About\n60 yards north-west of a Cave\nSkog "..
																"and 60 yards north of a\nSpirit Healer"] },   
			["43"] = { ["x"] = 52.92, ["y"] = 35.96, ["tip"] = L["In the El'dranil Shallows lake,\nunder large overhanging rocks"] },
			["44"] = { ["x"] = 53.89, ["y"] = 63.52, ["author"] = true, ["tip"] = L["Frequently listed online as \"by\nthe torch\". "..
																"Worth a run past"] },	-- Finese these coords 
			["45"] = { ["x"] = 54.05, ["y"] = 27.62, ["tip"] = L["Equidistant between a circular stone\nstructure to the south and the "..
																"foot\nof a sheer cliff rising to the north"] },
			["46"] = { ["x"] = 54.39, ["y"] = 25.92, ["tip"] = L["Within the \"claw\" of large\ncreeping, exposed tree roots"] },
			["47"] = { ["x"] = 54.76, ["y"] = 33.80, ["tip"] = L["In shallow water, near the shoreline.\nBasilisks roam the area"] },
			["48"] = { ["x"] = 54.83, ["y"] = 28.03, ["tip"] = L["At the foot of a large tree to the east and\na few yards from a "..
																"river to the west"] },
			["49"] = { ["x"] = 55.30, ["y"] = 55.81, ["tip"] = L["Nestled in a grassy patch\nat the side of the cliff"] },	-- not secret			
			["50"] = { ["x"] = 55.58, ["y"] = 32.74, ["tip"] = L["At the foot of rocks rising to the north-\neast and a tree to the "..
																"north-west"] },
			["51"] = { ["x"] = 55.59, ["y"] = 10.23, ["tip"] = L["On a flatter, south-west sloping\nsection of a hill-side, north-west\n"..
																"of the Ley-Ruins"] },
			["52"] = { ["x"] = 55.97, ["y"] = 29.32, ["tip"] = L["Inside the south-eastern pavilion,\na wing of the main structure"] },
			["53"] = { ["x"] = 56.2, ["y"] = 40.5, ["author"] = true, ["tip"] = L["Submerged, under the south-\nwestern edge of the bridge"] },
			["54"] = { ["x"] = 56.49, ["y"] = 12.46, ["tip"] = L["Several yards from a pink flower,\nbelow and slightly west of the\n"..
																"most intact part of the Ley-Ruins"] },
			["55"] = { ["x"] = 56.93, ["y"] = 38.91, ["tip"] = L["On the rocks above the water line.\nClearly visible on approach"] }, 
			["56"] = { ["x"] = 57.09, ["y"] = 31.26, ["tip"] = L["At the eastern end of a horizintal\nbroken masonry pillar"] },
			["57"] = { ["x"] = 57.41, ["y"] = 16.69, ["tip"] = L["Near an edge overlooking the\nshallow Ley-Ruins chasm"] },
			["58"] = { ["x"] = 58.24, ["y"] = 24.49, ["tip"] = L["At the base of the south side of a large\ntree, between a rock and a bush"] },
			["59"] = { ["x"] = 59.05, ["y"] = 37.48, ["tip"] = L["East of a female night elf statue, just\nbeyond the paving masonry and "..
																"flanked\nby two tall, thin cylindrical trees. A dry\nwater feature and "..
																"sit-down benches\nare < 10 yards to the south-west"] },
			["60"] = { ["x"] = 59.38, ["y"] = 38.64, ["tip"] = L["North-east side of a Naga tent,\njust before the grass gives way\nto "..
																"rocks rising to the north"] },
			["61"] = { ["x"] = 59.63, ["y"] = 37.93, ["tip"] = L["Very close to the western side of a large\ntree, 10 yards from a "..
																"drop-off to the west"] },
			["62"] = { ["x"] = 59.75, ["y"] = 27.85, ["tip"] = L["Location not verified by the author"] },	-- *
			["63"] = { ["x"] = 60.14, ["y"] = 48.90, ["tip"] = L["Alongside the base of a small ledge with the\nland itself running "..
																"down towards the south.\nA tree is visible to the north-west "] },
			["64"] = { ["x"] = 60.15, ["y"] = 54.68, ["tip"] = L["Westwards and just beyond the stone\nwork of a pavilion in the Garden "..
																"of\nElune, under a lattice-like canopy"] },
			["65"] = { ["x"] = 60.19, ["y"] = 34.99, ["tip"] = L["On the south-east edge of Lyndras'\ncircular pavilion, amongst fallen /"..
																"\nshattered debris"] },
			["66"] = { ["x"] = 60.37, ["y"] = 46.66, ["tip"] = L["On the flat rock immediately to the\nleft (west) of the cave entrance"] },
			["67"] = { ["x"] = 60.91, ["y"] = 17.12, ["tip"] = L["Eastern side of a tree,\nadjacent to a large rock"] },
			["68"] = { ["x"] = 61.71, ["y"] = 39.98, ["tip"] = L["On the eastern side of a tree, further away\nto the south-west are the "..
																"ruins of a multi-\nlevel pavilion, a rocky rise is to the east"] },
			["69"] = { ["x"] = 61.91, ["y"] = 30.91, ["tip"] = L["West of a tree, with another tree\nand some rocks nearby. A sheer\n"..
																"drop-off to the west"] },
			["70"] = { ["x"] = 62.20, ["y"] = 54.69, ["tip"] = L["South-east side of the tree, nestled\nbetween the trunk and a large root"] },
			["71"] = { ["x"] = 62.28, ["y"] = 35.82, ["tip"] = L["South-east of a large tree and south-\nwest of a much thinner tree, "..
																"28 yards\nnorth-east of a Hatecoil Skrog"] },
			["72"] = { ["x"] = 62.31, ["y"] = 40.49, ["tip"] = L["On the northern side of a tent,\nalongside a pillar to the north\nand "..
																"a small rock to the east"] },
			["73"] = { ["x"] = 62.66, ["y"] = 52.46, ["tip"] = L["North side of a rock overgrown with the\nroots of a tree. West is a "..
																"nearby stream"] },
			["74"] = { ["x"] = 63.53, ["y"] = 46.22, ["tip"] = L["Western side of a large tree.\nSafely out of hostile NPC\nrange if you "..
																"hug the cliff edge"] },
			["75"] = { ["x"] = 64.39, ["y"] = 33.22, ["tip"] = L["On the northern side of a tent,\nwith a bent-over tree to the west"] },
			["76"] = { ["x"] = 65.47, ["y"] = 29.53, ["tip"] = L["Inside the log. Enter\nfrom the north"] },
			["77"] = { ["x"] = 65.08, ["y"] = 50.81, ["tip"] = L["Against the south-east side of the\ntree, between two shrubs. A small\n"..
																"ledge is to the east / south-east"] },
			["78"] = { ["x"] = 65.52, ["y"] = 42.52, ["tip"] = L["South-east of a naga tent, just to the right\nside at the start of a "..
																"path leading up from\nthe shore. A star-shaped seashell is west"] },
			["79"] = { ["x"] = 65.58, ["y"] = 38.43, ["tip"] = L["On the northern side of the central eastern north-\nsouth bridge. On a "..
																"path leading down to the\nriver banks on the western side of the bridge"] },
			["80"] = { ["x"] = 67.01, ["y"] = 51.94, ["tip"] = L["Southern ledge of The Runied\nSanctum Pavilion, about\nmidway between "..
																"two pillars"] },
			["81"] = { ["x"] = 67.13, ["y"] = 46.29, ["tip"] = L["Set on bare ground, south-east and\nalongside a large broken tree "..
																"branch,\nwith a small boulder to its north-west"] },
			["82"] = { ["x"] = 67.73, ["y"] = 32.81, ["tip"] = L["Far south from the Felblaze spire, on a\ngrassy level area high above "..
																"the water"] },
			["83"] = { ["x"] = 68.22, ["y"] = 24.05, ["tip"] = L["North-east from the centre of the demon\ncamp, on the grassy rise "..
																"before a steep\ndrop-off. Behind some rocks"] },
			num = 83, },

		C = {
			["1"] = { ["x"] = 30.56, ["y"] = 26.31, ["xMin"] = 30.14, ["xMax"] = 31.16, ["yMin"] = 23.89, ["yMax"] = 26.80, 
					["author"] = true, ["tip"] = L["Online reports cite an ".. L["Ephemeral Crystal"].. "\nin this cave. Very likely"] }, --????					
			["2"] = { ["x"] = 34.58, ["y"] = 35.72, ["xMin"] = 34.37, ["xMax"] = 34.71, ["yMin"] = 35.44, ["yMax"] = 35.90, 
					["tip"] = L["Just to the right as you enter"] },
			["3"] = { ["x"] = 41.50, ["y"] = 30.80, ["xMin"] = 41.26, ["xMax"] = 41.54, ["yMin"] = 30.58, ["yMax"] = 31.13, 
					["author"] = true, ["tip"] = L["On a flat, low rock on the right side of the entrance"] },	-- like to finese the coords
			["4"] = { ["x"] = 42.65, ["y"] = 18.09, ["xMin"] = 42.21, ["xMax"] = 44.17, ["yMin"] = 16.8, ["yMax"] = 18.36, 
					["tip"] = L["On a small rock with a skull to its\nnorth-west side and a backbone\nand ribs skeleton to its north-east"] },
			["5"] = { ["x"] = 49.10, ["y"] = 8.22, ["xMin"] = 48.92, ["xMax"] = 50.07, ["yMin"] = 7.5, ["yMax"] = 9.23, 
					["tip"] = L["Centrally placed on a flat rock\nthat projects into the water"] },
			["6"] = { ["x"] = 50.16, ["y"] = 23.46, ["xMin"] = 47.26, ["xMax"] = 52.05, ["yMin"] = 19.56, ["yMax"] = 25.12, 
					["tip"] = L["Amongst the purple crystals. Look\ncarefully as only the tip is visible\nand it is a darker purple"] },					
			["7"] = { ["x"] = 50.37, ["y"] = 56.92, ["xMin"] = 50.33, ["xMax"] = 50.61, ["yMin"] = 56.66, ["yMax"] = 57.2, 
					["tip"] = L["Inside the cave, on a\nchest with crescent motif"] },
			["8"] = { ["x"] = 50.55, ["y"] = 20.33, ["xMin"] = 47.26, ["xMax"] = 52.05, ["yMin"] = 19.56, ["yMax"] = 25.12,
					["tip"] = L["Against a northern wall, a small\ncrystal to its north-east and a\nmuch larger one beyond that"] },

			["9"] = { ["x"] = 50.77, ["y"] = 50.00, ["xMin"] = 49.81, ["xMax"] = 50.99, ["yMin"] = 48.96, ["yMax"] = 50.62, 
					["tip"] = L["On the eastern side of two seats and a table"] },
			["10"] = { ["x"] = 53.82, ["y"] = 27.99, ["xMin"] = 52.78, ["xMax"] = 53.97, ["yMin"] = 27.36, ["yMax"] = 29.45, 
					["tip"] = L["Between four vertebrae\nand a natural rock pillar"] },
			["11"] = { ["x"] = 54.86, ["y"] = 52.33, ["xMin"] = 54.63, ["xMax"] = 54.98, ["yMin"] = 52, ["yMax"] = 52.43, 
					["tip"] = L["Inside the cave, on a flat, low rock\non the right side of the entrance"] },
			["12"] = { ["x"] = 56.92, ["y"] = 26.00, ["xMin"] = 55.83, ["xMax"] = 57.28, ["yMin"] = 24.48, ["yMax"] = 26.16, 
					["tip"] = L["Against a wall, with a small rock\nto its east and a floor-to-ceiling\nstone construct due north"] },
			["13"] = { ["x"] = 57.64, ["y"] = 42.29, ["xMin"] = 57.33, ["xMax"] = 58.42, ["yMin"] = 41.87, ["yMax"] = 43.63, 
					["tip"] = L["Against a wall, behind four vertebrae,\npartly concealed by a stone ceremonial\nstructure to its north-"..
					"east. Golk the\nRumble is 16-17 yards to the south"] },
			["14"] = { ["x"] = 58.50, ["y"] = 45.62, ["xMin"] = 57.89, ["xMax"] = 59.78, ["yMin"] = 44.26, ["yMax"] = 45.9, 
					["tip"] = L["On a small rock with a skull to its\nnorth-west side and a backbone\nand ribs skeleton to its north-"..
					"east.\n30 yards south of Eksis"] },
			["15"] = { ["x"] = 61.14, ["y"] = 30.43, ["xMin"] = 60.32, ["xMax"] = 61.29, ["yMin"] = 30.07, ["yMax"] = 30.49, 
					["tip"] = L["On a flat rock, nestling between exposed\nroots and the rock wall"] },
			["16"] = { ["x"] = 63.51, ["y"] = 54.13, ["xMin"] = 62.63, ["xMax"] = 63.91, ["yMin"] = 52.67, ["yMax"] = 54.38, 
					["tip"] = L["On a skeleton in a nook\nframed by flat stone slabs"] },
			
			num = 16, },

		O = {
			["1"] = { ["x"] = 45.44, ["y"] = 29.89, ["tip"] = L["Sitting on some gold which has spilt from a\nchest. Not visible from  "..
																"the northern entrance"] },
			["2"] = { ["x"] = 50.76, ["y"] = 77.41, ["tip"] = L["Inside a wrecked ship. Visible\nfrom all approaches"] },
			["3"] = { ["x"] = 84.14, ["y"] = 81.75, ["tip"] = L["Between a rock wall and broken\nbeams on its western side and\nwater "..
																"directly north"] },

			num = 3, },

		S = {
			["1"] = { ["x"] = 30.12, ["y"] = 23.72, ["tip"] = L["Grey Shoals cave entrance\n1 x "].. L["Ephemeral Crystal"] },
			["2"] = { ["x"] = 34.36, ["y"] = 36.06 , ["tip"] = L["Entrance to small cave\n1 x "].. L["Ephemeral Crystal"] },
			["3"] = { ["x"] = 41.59, ["y"] = 31.31, ["tip"] = L["Grizzly cave\n1 x "].. L["Ephemeral Crystal"] },
			["4"] = { ["x"] = 44.33, ["y"] = 17.28, ["tip"] = L["Runa's Hovel cave entrance\n1 x "].. L["Ephemeral Crystal"] },
			["5"] = { ["x"] = 45.50, ["y"] = 55.50, ["tip"] = L["Oceanus Cove west entrance\n3 x "].. L["Ephemeral Crystal"] },
			["6"] = { ["x"] = 47.87, ["y"] = 25.08, ["tip"] = L["Entrance to the Leyhollow\n2 x "].. L["Ephemeral Crystal"] },
			["7"] = { ["x"] = 48.49, ["y"] = 50.35, ["tip"] = L["Oceanus Cove north entrance\n3 x "].. L["Ephemeral Crystal"] },
			["8"] = { ["x"] = 48.91, ["y"] = 59.74, ["tip"] = L["Oceanus Cove south entrance\n3 x "].. L["Ephemeral Crystal"] },
			["9"] = { ["x"] = 50.10, ["y"] = 48.62, ["tip"] = L["Entrance to main Shipwreck Arena cave\n1 x "].. L["Ephemeral Crystal"] },
			["10"] = { ["x"] = 50.22, ["y"] = 7.70, ["tip"] = L["Entrance to the Lair of the Deposed\n1 x "].. L["Ephemeral Crystal"] },
			["11"] = { ["x"] = 50.66, ["y"] = 57.34, ["tip"] = L["Cave entrance\n1 x "].. L["Ephemeral Crystal"] },
			["12"] = { ["x"] = 50.73, ["y"] = 59.33, ["tip"] = L["Oceanus Cove south-east entrance\n3 x "].. L["Ephemeral Crystal"] },
			["13"] = { ["x"] = 53.31, ["y"] = 29.72, ["tip"] = L["Entrance to Lothien cave\n1 x "].. L["Ephemeral Crystal"] },
			["14"] = { ["x"] = 54.60, ["y"] = 52.58, ["tip"] = L["The Old Coast Path Cave entrance\n1 x "].. L["Ephemeral Crystal"] },
			["15"] = { ["x"] = 55.70, ["y"] = 25.49, ["tip"] = L["Llothien river barrow entrance\n1 x "].. L["Ephemeral Crystal"] },
			["16"] = { ["x"] = 58.49, ["y"] = 41.60, ["tip"] = L["Hatecoil Slave Pen cave entrance\n1 x "].. L["Ephemeral Crystal"] },
			["17"] = { ["x"] = 59.86, ["y"] = 43.84, ["tip"] = L["Entrance to Eksis' Lair\n1 x "].. L["Ephemeral Crystal"] },
			["18"] = { ["x"] = 60.54, ["y"] = 46.56, ["tip"] = L["(Blue) Ley Portal cave entrance\n0 x "].. L["Ephemeral Crystal"] },
			["19"] = { ["x"] = 60.81, ["y"] = 30.56, ["tip"] = L["The Greenway cave entrance\naka Kira Iresoul's "..
																"cave\n1 x "].. L["Ephemeral Crystal"] },
			["20"] = { ["x"] = 64.15, ["y"] = 52.89, ["tip"] = L["Gloombound Barrow entrance\n1 x "].. L["Ephemeral Crystal"] },
			
			num = 20, }, 

		U = {
			["1"] = { ["x"] = 37.91, ["y"] = 37.43, ["author"] = true, ["tip"] = L["Nor'Danil Wellspring Barrow\n* Concealed "..
																"Entrance *\n? x "].. L["Ephemeral Crystal"] },
			["2"] = { ["x"] = 41.63, ["y"] = 86.04, ["author"] = true, ["tip"] = L["Western end of \"tunnel\" cave\n? x "].. 
																L["Ephemeral Crystal"] },
			["3"] = { ["x"] = 44.95, ["y"] = 76.01, ["author"] = true, ["tip"] = L["Fiend Lair\n? x "].. L["Ephemeral Crystal"] },
			["4"] = { ["x"] = 45.12, ["y"] = 87.05, ["author"] = true, ["tip"] = L["Eastern end of \"tunnel\" cave\n? x "].. 
																L["Ephemeral Crystal"] },
			["5"] = { ["x"] = 49.32, ["y"] = 26.15, ["author"] = true, ["tip"] = L["Azurewing Repose cave entrance\n? x "].. 
																L["Ephemeral Crystal"] },
			["6"] = { ["x"] = 49.65, ["y"] = 89.87, ["author"] = true, ["tip"] = L["Salteye murloc cave\n? x "].. L["Ephemeral Crystal"] },
			["7"] = { ["x"] = 49.73, ["y"] = 85.47, ["author"] = true, ["tip"] = L["Malignant Stalker cave\n? x "].. L["Ephemeral Crystal"] },
			["8"] = { ["x"] = 50.83, ["y"] = 83.86, ["author"] = true, ["tip"] = L["Cliffdweller Fox lair\n? x "].. L["Ephemeral Crystal"] },
			["9"] = { ["x"] = 51.08, ["y"] = 75.67, ["author"] = true, ["tip"] = L["Cove Gull cave entrance\n? x "].. 
																L["Ephemeral Crystal"] },
			["10"] = { ["x"] = 51.88, ["y"] = 33.10, ["author"] = true, ["tip"] = L["Gangamesh's Den entrance\n? x "].. 
																L["Ephemeral Crystal"] },
			["11"] = { ["x"] = 52.38, ["y"] = 79.65, ["author"] = true, ["tip"] = L["Entrance to Withered J'im's cave\n? x "].. 
																L["Ephemeral Crystal"] },
			["12"] = { ["x"] = 56.04, ["y"] = 63.20, ["author"] = true, ["tip"] = L["Temple of a Thousand Lights\ncave entrance\n? x "].. 
																L["Ephemeral Crystal"] },
			["13"] = { ["x"] = 58.58, ["y"] = 79.12, ["author"] = true, ["tip"] = L["Dead Man's Bay cave #3\n? x "].. L["Ephemeral Crystal"] },
			["14"] = { ["x"] = 59.63, ["y"] = 68.16, ["author"] = true, ["tip"] = L["Dead Man's Bay cave #1\n? x "].. L["Ephemeral Crystal"] },
			["15"] = { ["x"] = 59.80, ["y"] = 56.94, ["author"] = true, ["tip"] = L["The Mak'rana cave entrance\n? x "].. L["Ephemeral Crystal"] },
			["16"] = { ["x"] = 61.29, ["y"] = 70.83, ["author"] = true, ["tip"] = L["Dead Man's Bay cave #2\n? x "].. L["Ephemeral Crystal"] },
			
			num = 16, }, 
		}

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		MiniMap Setup
--		=============
--
--------------------------------------------------------------------------------------------------------------------------------------------

-- Mini holds the textures/tooltips for the Minimap pins plus a few flags/fields used also on the World Map.
-- In particular, the blinking eye fields will be saved here (prior to 8.0.1 it was only reasonably feasible to blink on the Minimap).
-- This is sufficient to establish a large enough pool of random eyeIDs

local mini = { 
		zoom = 0, width = 0, height = 0, xPlayer = 0, yPlayer = 0, tooltipShowing = false, indoors = false, wasInCorrectZone = false, 
		mapAreaInID = 0, firstTimeShowing = true, leftMouseUp = false,
		radii = { [0] = (233 + 1/3), [1] = 200, [2] = (166 + 2/3), [3] = (133 + 1/3), [4] = 100, [5] = (66 + 2/3) },
		zoomOceanusCove = { [0] = { x = 0.203, y = 0.295 }, [1] = { x = 0.185, y = 0.273 }, [2] = { x = 0.166, y = 0.25 },
							[3] = { x = 0.138, y = 0.207 }, [4] = { x = 0.124, y = 0.18 }, [5] = { x = 0.115, y = 0.175 }, },
		zoomIndoors = { [0] = { x = 0.0192, y = 0.0283 }, [1] = { x = 0.0182, y = 0.027 }, [2] = { x = 0.0165, y = 0.0252 },
						[3] = { x = 0.0137, y = 0.0204 }, [4] = { x = 0.012, y = 0.0182 }, [5] = { x = 0.0115, y = 0.017 }, }, }

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Assign Pins to the Mini Map
--		===========================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function AssignMiniMapPins()

	-- With the Minimap we create tables of textures, with the World Map we create tables of buttons and textures
						
	for k, v in pairs( tips ) do
		local t = ( k == "S" or k == "U" ) and "S" or "E"
		mini[ k ] = {}
		for i = 1, v.num do
			mini[ k ][ i ] = Minimap:CreateTexture( nil, "OVERLAY" )
			mini[ k ][ i ]:SetAlpha( 0 )
			local textureID = ( author and tips[ k ][ tostring( i ) ].author ) 
									and "3"
									or ( LongForgottenHippogryphDB[ "saved".. k ][ tostring( i ) ] 
											or LongForgottenHippogryphDB[ "texture".. k ] )
			mini[ k ][ i ]:SetTexture( textures[ t ][ textureID ] )
			mini[ k ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ textureID ] ) )
			mini[ k ][ i ]:SetSize( 0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ textureID ],
									0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ textureID ] )
			mini[ k ][ i ].tooltip = v[ tostring( i ) ].tip
			mini[ k ][ i ].x = v[ tostring( i ) ].x
			mini[ k ][ i ].y = v[ tostring( i ) ].y
		end
	end
	
	Minimap:HookScript( "OnMouseUp", function( self, button ) if ( button == "LeftButton" ) then mini.leftMouseUp = true end end )
	
	mini.firstTimeShowing = false
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Show on the Mini Map
--		====================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function AdjustMinimapCoordinates( x, y )

	local distX, distY, scaledX, scaledY, stepX, stepY = mini.xPlayer - x, mini.yPlayer - y

	if ( mini.indoors == true ) then
		if ( mini.mapAreaInID == 632 ) then	-- Oceanus Cove
			scaledX = distX / ( mini.radii[ mini.zoom ] * mini.zoomOceanusCove[ mini.zoom ].x )
			scaledY = distY / ( mini.radii[ mini.zoom ] * mini.zoomOceanusCove[ mini.zoom ].y )
		else
			scaledX = distX / ( mini.radii[ mini.zoom ] * mini.zoomIndoors[ mini.zoom ].x )
			scaledY = distY / ( mini.radii[ mini.zoom ] * mini.zoomIndoors[ mini.zoom ].y )
		end
	else
		scaledX, scaledY = distX / ( mini.radii[ mini.zoom ] * 0.03 ), distY / ( mini.radii[ mini.zoom ] * 0.045 )
	end

	if ( GetCVar( "rotateMinimap" ) == "1" ) then
		local cosTheta, sinTheta = cos( GetPlayerFacing() ), sin( GetPlayerFacing() )
		scaledX, scaledY = cosTheta * scaledX - sinTheta * scaledY, sinTheta * scaledX + cosTheta * scaledY
	end

	local pointRadiusSquared = scaledX^2 + scaledY^2

	if pointRadiusSquared > 0.2025 then
		local reductionRatio = 0.45 / sqrt( pointRadiusSquared )
		scaledX, scaledY = scaledX * reductionRatio, scaledY * reductionRatio
	end

	return -scaledX * mini.width, scaledY * mini.height
end

local function HideAllMini( tipType )
	if ( tipType == "C" ) or ( mini[ tipType ][ 1 ]:GetAlpha() == 1 ) then
		for i = 1, tips[ tipType ].num do
			mini[ tipType ][ i ]:SetAlpha( 0 )
		end
	end
end

local function ShowOnMiniMap()

	if not Minimap:IsShown() then return end
	if ( mini.firstTimeShowing == true ) then AssignMiniMapPins() end
	
	-- Identify the current map and obtain player's (X,Y)

	mini.mapAreaInID = GetBestMapForUnit( "player" ) or 0
	
	-- Hide decisions
	
	if not ( ( mini.mapAreaInID == 630 ) or ( mini.mapAreaInID == 632 ) ) then
		if ( mini.wasInCorrectZone == true ) then
			for k, v in pairs( tips ) do
				for i = 1, v.num do
					mini[ k ][ i ]:ClearAllPoints( 0 )
				end
			end
			HideAllMini( "E" )
			HideAllMini( "C" )
			HideAllMini( "O" )
			HideAllMini( "S" )
			HideAllMini( "U" )
			mini.wasInCorrectZone = false
		end
		return
	end
	
	for k, v in pairs( tips ) do
		for i = 1, v.num do
			mini[ k ][ i ]:ClearAllPoints( 0 )
		end
	end
	
	if ( LongForgottenHippogryphDB.hideCrystals == "y" ) and ( mini.wasInCorrectZone == true ) then 
		HideAllMini( "E" )
		HideAllMini( "C" )
		HideAllMini( "O" )
		HideAllMini( "S" )
	end
	if ( LongForgottenHippogryphDB.hideSpecials == "y" ) and ( mini.wasInCorrectZone == true ) then 
		HideAllMini( "U" )
	end
	if ( LongForgottenHippogryphDB.hideCrystals == "y" ) and ( LongForgottenHippogryphDB.hideSpecials == "y" ) then
		mini.wasInCorrectZone = false
		return
	end	
	
	if GetPlayerMapPosition( mini.mapAreaInID, "player" ) then
		mini.xPlayer, mini.yPlayer = GetPlayerMapPosition( mini.mapAreaInID, "player" ):GetXY()
	end
	
	mini.xPlayer, mini.yPlayer = ( mini.xPlayer or 0 ) * 100, ( mini.yPlayer or 0 ) * 100
	if ( mini.xPlayer == 0 ) and ( mini.yPlayer == 0 ) then
		HideAllMini( "E" )
		HideAllMini( "C" )
		HideAllMini( "O" )
		HideAllMini( "S" )
		HideAllMini( "U" )
		return
	end

	mini.wasInCorrectZone = true
	mini.indoors = IsIndoors()
	
	if ( mini.mapAreaInID == 630 ) then
		HideAllMini( "C" )						-- We'll selectively show (below)
		HideAllMini( "O" )
		if ( mini.indoors == true ) then
			HideAllMini( "E" )
			HideAllMini( "S" )
			HideAllMini( "U" )
		end
	else
		HideAllMini( "E" )
		HideAllMini( "C" )
		HideAllMini( "S" )
		HideAllMini( "U" )
	end

	-- Show decisions

	mini.zoom = Minimap:GetZoom()
	mini.width, mini.height = Minimap:GetWidth(), Minimap:GetHeight()

	if ( mini.mapAreaInID == 632 ) then
		if ( LongForgottenHippogryphDB.hideCrystals == "y" ) then return end
		for i = 1, tips.O.num do
			mini.O[ i ]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( mini.O[ i ].x, mini.O[ i ].y ) )
			mini.O[ i ]:SetAlpha( 1 )
		end

	elseif ( mini.indoors == false ) then
		if ( LongForgottenHippogryphDB.hideCrystals == "n" ) then
			for i = 1, tips.E.num do
				mini.E[ i ]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( mini.E[ i ].x, mini.E[ i ].y ) )
				mini.E[ i ]:SetAlpha( 1 )
			end	
			for i = 1, tips.S.num do
				mini.S[ i ]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( mini.S[ i ].x, mini.S[ i ].y ) )
				mini.S[ i ]:SetAlpha( 1 )
			end	
		end
		if ( LongForgottenHippogryphDB.hideSpecials == "n" ) then
			for i = 1, tips.U.num do
				mini.U[ i ]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( mini.U[ i ].x, mini.U[ i ].y ) )
				mini.U[ i ]:SetAlpha( 1 )
			end
		end

	elseif ( LongForgottenHippogryphDB.hideCrystals == "n" ) then
		for i = 1, tips.C.num do
			if ( mini.xPlayer >= tips.C[ tostring(i) ].xMin ) and ( mini.xPlayer <= tips.C[ tostring(i) ].xMax )
							and ( mini.yPlayer >= tips.C[ tostring(i) ].yMin ) and ( mini.yPlayer <= tips.C[ tostring(i) ].yMax ) then 
				mini.C[ i ]:SetPoint( "CENTER", Minimap, "CENTER", AdjustMinimapCoordinates( mini.C[ i ].x, mini.C[ i ].y ) )
				mini.C[ i ]:SetAlpha( 1 )
			end
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		World Map Setup
--		===============
--
--------------------------------------------------------------------------------------------------------------------------------------------

-- All other AddOns supporting the mount just jumble the outdoor, Cove and cave pins together onto the World Map. This AddOn allows this
-- but also can prevent it by default

local worldMap = { applyToAll = false, width = 0, height = 0, firstTimeShowing = true, wasInCorrectZone = true,
					mapAreaLookID = 0, mapAreaLookOldID = 0, E = {}, C = {}, O = {}, S = {}, U = {} }

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		World Map Tooltips
--		==================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function WorldMapTooltipOnEnter( self )

	WorldMapTooltip:SetOwner( self, "ANCHOR_CURSOR" )
	if ( self.type == "S" ) or ( self.type == "U" )then
		WorldMapTooltip:SetText( "\124cFFBF00FF".. L[ "Cave Entrance" ] )
	else
		WorldMapTooltip:SetText( "\124cFFBF00FF".. L[ "Ephemeral Crystal" ] )
	end
	WorldMapTooltip:AddLine( self.tooltip )
	if ( LongForgottenHippogryphDB.showCoordinates == "y" ) then
		WorldMapTooltip:AddLine( "(".. format( "%.02f", self.x ).. ",".. format( "%.02f", self.y ).. ")" )
	end
	
	WorldMapTooltip:Show()
	
	if ( IsControlKeyDown() == true ) then
		local frame = EnumerateFrames()
		local activeChatFrameEditBox;
		while frame do
			if frame:IsVisible() then
				local name = frame:GetName()
				if name and find( name, "ChatFrame(%d+)EditBox" ) then
					activeChatFrameEditBox = frame
					break
				end
			end
			frame = EnumerateFrames( frame )
		end
		if activeChatFrameEditBox then
			local found = false
			if find( activeChatFrameEditBox:GetText(), L[ "Ephemeral Crystal" ] ) then
				found = true
			elseif find( activeChatFrameEditBox:GetText(), L[ "Cave Entrance" ] ) then
				found = true
			end
			if not found then
				activeChatFrameEditBox:Insert( ( ( self.type == "S" or self.type == "U" ) and L[ "Cave Entrance" ] 
																						  or L[ "Ephemeral Crystal" ] ).. 
						" @ (".. format( "%.02f", self.x ).. ",".. format( "%.02f", self.y ).. ") ".. " \"".. 
						gsub( self.tooltip, "\n", " " ).. "\"" )
			end
		end
	end
end

local function WorldMapTooltipOnLeave( self )
	WorldMapTooltip:Hide()
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Change Pins on the World Map			(and copy over to the Minimap)
--		============================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function ApplyPinSelection( arg0, typeIndex, tID )

	local t = ( typeIndex.type == "S" or typeIndex.type == "U" ) and "S" or "E"
	
	if ( worldMap.applyToAll == true ) then
		for k, v in pairs( tips ) do
			if ( ( t == "S" ) and ( k == "S" or k == "U" ) ) or ( ( t == "E" ) and ( k ~= "S" and k ~= "U" ) ) then
				LongForgottenHippogryphDB[ "texture".. k ] = tID
				LongForgottenHippogryphDB[ "saved".. k ] = {}
				for i = 1, v.num do
					worldMap[ k ][ i ].pinTexture:SetTexture( textures[ t ][ tID ] )
					worldMap[ k ][ i ].pinTexture:SetTexCoord( unpack( textures[ t ].coords[ tID ] )  )
					worldMap[ k ][ i ].pinTexture:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
															LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
					worldMap[ k ][ i ]:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
												LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
					mini[ k ][ i ]:SetTexture( textures[ t ][ tID ] )
					mini[ k ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ tID ] )  )
					mini[ k ][ i ]:SetSize( 0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
											0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
				end
			end
		end
	else
		local i = tonumber( typeIndex.index )
		LongForgottenHippogryphDB[ "saved".. typeIndex.type ][ typeIndex.index ] = tID
		worldMap[ typeIndex.type ][ i ].pinTexture:SetTexture( textures[ t ][ tID ] )
		worldMap[ typeIndex.type ][ i ].pinTexture:SetTexCoord( unpack( textures[ t ].coords[ tID ] )  )
		worldMap[ typeIndex.type ][ i ].pinTexture:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
															LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
		worldMap[ typeIndex.type ][ i ]:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
												LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
		mini[ typeIndex.type ][ i ]:SetTexture( textures[ t ][ tID ] )
		mini[ typeIndex.type ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ tID ] )  )
		mini[ typeIndex.type ][ i ]:SetSize( 0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
											0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
	end
end

local function ToggleApplyToAll()
	worldMap.applyToAll = not worldMap.applyToAll
end

local function ScalingStuffCopiedFromBlizzCode()

	-- Copied from UIDropDownMenu.lua

	local uiScale
	local uiParentScale = UIParent:GetScale()
	if ( GetCVar( "useUIScale" ) == "1" ) then
		uiScale = tonumber( GetCVar( "uiscale" ) )
		if ( uiParentScale < uiScale ) then
			uiScale = uiParentScale
		end
	else
		uiScale = uiParentScale
	end
	local cursorX, cursorY = GetCursorPosition()
	cursorX = cursorX / uiScale
	cursorY =  cursorY / uiScale
	local listFrame = _G[ "DropDownList1" ]
	listFrame:SetScale( uiScale )
	listFrame:ClearAllPoints()
	listFrame:SetPoint( "TOPLEFT", nil, "BOTTOMLEFT", cursorX, cursorY)
	listFrame:Show()
	listFrame.showTimer = UIDROPDOWNMENU_SHOW_TIME
	listFrame.isCounting = 1
end

local function WorldMapTextureSelection( typeIndex )

	local t = ( typeIndex.type == "S" ) and "S" or "E"
	worldMap.applyToAll = false
	local currentTexture = LongForgottenHippogryphDB[ "saved".. typeIndex.type ][ typeIndex.index ] or 
							LongForgottenHippogryphDB[ "texture".. typeIndex.type ]	
	local info = _G[ "DropDownList1" ]
	if info then
		UIDropDownMenu_InitializeHelper( info )
	end	
	info = UIDropDownMenu_CreateInfo()
	info.isTitle = true
	info.text = ( t == "S" or t == "U" ) and L[ "Cave Entrance" ] or L[ "Ephemeral Crystal" ]
	info.notCheckable = true
	info.isNotRadio = true
	UIDropDownMenu_AddButton( info )
	info.isTitle = nil
	info.disabled = nil		
	info.notCheckable = nil
	info.keepShownOnClick = true
	info.checked = worldMap.applyToAll
	info.text = L[ "Apply to |cFFCA64EFall|r pins" ]
	info.func = ToggleApplyToAll
	UIDropDownMenu_AddButton( info )
	info.notCheckable = true
	info.text = nil
	UIDropDownMenu_AddButton( info )
	info.notCheckable = nil
	info.keepShownOnClick = nil
	info.func = ApplyPinSelection	
	info.arg1 = typeIndex
	for i = 1, textures[ t ].num do
		info.arg2 = tostring( i )
		info.checked = currentTexture == info.arg2
		info.text = textures[ t ].name[ info.arg2 ]
		info.icon = textures[ t ][ info.arg2 ]
		UIDropDownMenu_AddButton( info )
	end
	
	ScalingStuffCopiedFromBlizzCode()
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Assign Pins to the World Map
--		============================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function AdjustWorldMapCoordinates( x, y )
	return ( x - 50 ) * worldMap.width / 100, ( worldMap.height / 2 ) - ( worldMap.height * y / 100 )
end

local function NewlyShowingWorldMapZone()		-- Assign the clickable buttons and textures to the correct location on the World Map

	if not ( ( worldMap.mapAreaLookID == 630 ) or ( worldMap.mapAreaLookID == 632 ) ) then return end

	worldMap.width = WorldMapFrame.ScrollContainer and WorldMapFrame.ScrollContainer.Child:GetWidth() or WorldMapDetailFrame:GetWidth()
	worldMap.height = WorldMapFrame.ScrollContainer and WorldMapFrame.ScrollContainer.Child:GetHeight() or WorldMapDetailFrame:GetHeight()
	
	for k, v in pairs( tips ) do
		for i = 1, v.num do
			local x, y = AdjustWorldMapCoordinates( v[ tostring(i) ].x, v[ tostring(i) ].y )
			worldMap[ k ][ i ].pinTexture:ClearAllPoints()
			worldMap[ k ][ i ].pinTexture:SetPoint( "CENTER", WorldMapFrame.ScrollContainer.Child, "CENTER", x, y )
			worldMap[ k ][ i ]:ClearAllPoints()
			worldMap[ k ][ i ]:SetPoint( "CENTER", WorldMapFrame.ScrollContainer.Child, "CENTER", x, y )
		end
	end
	
	worldMap.mapAreaLookOldID = worldMap.mapAreaLookID
end

local function AssignWorldMapPins()

	local function CreateWorldMapPin( typeIndex )
		local pin = CreateFrame( "Button", "NE".. lower( typeIndex.type ).. typeIndex.index, 
									WorldMapFrame.ScrollContainer.Child, UIDropDownMenuTemplate )
		pin.tooltip = tips[ typeIndex.type ][ typeIndex.index ].tip
		pin.x = tips[ typeIndex.type ][ typeIndex.index ].x
		pin.y = tips[ typeIndex.type ][ typeIndex.index ].y
		pin.type = typeIndex.type
		pin:HookScript( "OnEnter", WorldMapTooltipOnEnter )
		pin:HookScript( "OnLeave", WorldMapTooltipOnLeave )
		pin:HookScript( "OnClick", function( self, button ) WorldMapTextureSelection( typeIndex ) end )
		local t = ( typeIndex.type == "S" or typeIndex.type == "U" ) and "S" or "E"
		local textureID = ( author and tips[ typeIndex.type ][ typeIndex.index ].author ) 
							and "3" 
							or LongForgottenHippogryphDB[ "saved".. typeIndex.type ][ typeIndex.index ]
							or LongForgottenHippogryphDB[ "texture".. typeIndex.type ]
		local pinTexture = pin:CreateTexture( nil, "OVERLAY" )
		pinTexture:SetTexture( textures[ t ][ textureID ] )
		pinTexture:SetTexCoord( unpack( textures[ t ].coords[ textureID ] ) )
		pin:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ textureID ], 
						LongForgottenHippogryphDB.pinSize * textures[ t ].size[ textureID ] )
		pinTexture:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ textureID ], 
						LongForgottenHippogryphDB.pinSize * textures[ t ].size[ textureID ] )		
		pin.pinTexture = pinTexture
		pin:SetFrameStrata( "HIGH" )
		pin:Hide()
		return pin
	end

	for k, v in pairs( tips ) do
		for i = 1, v.num do
			worldMap[ k ][ i ] = CreateWorldMapPin( { type = k, index = tostring( i ) } )
		end
	end

	worldMap.firstTimeShowing = false
	NewlyShowingWorldMapZone()
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Show on the World Map
--		=====================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function HideWorldMap( tipType )
	if worldMap[ tipType ][ 1 ]:IsVisible() then
		for i = 1, tips[ tipType ].num do
			worldMap[ tipType ][ i ]:Hide()
		end
	end
end

local function ShowOnWorldMap()

	-- From OnUpdate cycle. All decision making logic re show/hide goes in this block

	if not WorldMapFrame:IsShown() then return end			
	if ( worldMap.firstTimeShowing == true ) then 
		AssignWorldMapPins()
	else
		worldMap.mapAreaLookID = WorldMapFrame:GetMapID() or 0
		if ( worldMap.mapAreaLookID ~= worldMap.mapAreaLookOldID ) then
			NewlyShowingWorldMapZone()
		end
	end
	
	-- Hide decisions

	if not ( ( worldMap.mapAreaLookID == 630 ) or ( worldMap.mapAreaLookID == 632 ) ) then		-- Azsuna / Oceanus Cove
		if ( worldMap.wasInCorrectZone == true ) then
			HideWorldMap( "E" )
			HideWorldMap( "C" )
			HideWorldMap( "O" )
			HideWorldMap( "S" )
			HideWorldMap( "U" )
			worldMap.wasInCorrectZone = false
		end
		return
	end
	
	if ( worldMap.wasInCorrectZone == true ) then
		if ( LongForgottenHippogryphDB.hideCrystals == "y" ) then 
			HideWorldMap( "E" )
			HideWorldMap( "O" )
			HideWorldMap( "S" )
		end
		if ( LongForgottenHippogryphDB.hideSpecials == "y" ) then 
			HideWorldMap( "U" )
		end
		if ( LongForgottenHippogryphDB.hideCrystals == "y" ) and ( LongForgottenHippogryphDB.hideSpecials == "y" ) then
			HideWorldMap( "C" )
			worldMap.wasInCorrectZone = false
			return
		end
		if ( worldMap.mapAreaLookID == 632 ) then		-- Oceanus Cove
			if ( LongForgottenHippogryphDB.hideCrystals == "n" ) then 
				HideWorldMap( "E" )
				HideWorldMap( "S" )
			end
			if ( LongForgottenHippogryphDB.hideSpecials == "n" ) then
				HideWorldMap( "U" )
			end
		else
			if ( LongForgottenHippogryphDB.hideCrystals == "n" ) then 
				HideWorldMap( "O" )
			end
		end
	else
		worldMap.wasInCorrectZone = true
	end
	
	-- Show decisions
	
	if ( worldMap.mapAreaLookID == 632 ) then		-- Oceanus Cove
		if ( LongForgottenHippogryphDB.hideCrystals == "n" ) then 
			for i = 1, tips.O.num do
				worldMap.O[ i ]:Show()
			end
		end
	else
		if ( LongForgottenHippogryphDB.hideCrystals == "n" ) then 
			for i = 1, tips.E.num do
				worldMap.E[ i ]:Show()
			end
			for i = 1, tips.S.num do
				worldMap.S[ i ]:Show()
			end
		end
		if ( LongForgottenHippogryphDB.hideSpecials == "n" ) then
			for i = 1, tips.U.num do
				worldMap.U[ i ]:Show()
			end
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		World Map's "Magnifying Glass" Drop Down Menu Options
--		=====================================================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local function ToggleCrystals()
	LongForgottenHippogryphDB.hideCrystals = (  LongForgottenHippogryphDB.hideCrystals == "y" ) and "n" or "y"
	if ( worldMap.mapAreaLookID == 630 ) or ( worldMap.mapAreaLookID == 632 ) then
		ShowOnWorldMap()
	end
end
local function ToggleSpecials()
	LongForgottenHippogryphDB.hideSpecials = ( LongForgottenHippogryphDB.hideSpecials == "y" ) and "n" or "y"
	if ( worldMap.mapAreaLookID == 630 ) or ( worldMap.mapAreaLookID == 632 ) then
		ShowOnWorldMap()
	end
end
local function ToggleCoordinates()
	LongForgottenHippogryphDB.showCoordinates = ( LongForgottenHippogryphDB.showCoordinates == "y" ) and "n" or "y"
end

local function ResetPins()

	for k, v in pairs( tips ) do
		local t = ( k == "S" or k == "U" ) and "S" or "E"
		local tID = LongForgottenHippogryphDB[ "texture".. k ]
		LongForgottenHippogryphDB[ "saved".. k ] = {}
		for i = 1, v.num do
			worldMap[ k ][ i ].pinTexture:SetTexture( textures[ t ][ tID ] )
			worldMap[ k ][ i ].pinTexture:SetTexCoord( unpack( textures[ t ].coords[ tID ] ) )
			mini[ k ][ i ]:SetTexture( textures[ t ][ tID ]  )
			mini[ k ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ tID ] ) )
			worldMap[ k ][ i ].pinTexture:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
													LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
			worldMap[ k ][ i ]:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
										LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
			mini[ k ][ i ]:SetSize( 0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
									0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
		end
	end
	
	ShowOnWorldMap()
end

local function GoToAzsuna( info )
	WorldMapFrame:SetMapID( 630 )
end

local function GoToOceanusCove()
	WorldMapFrame:SetMapID( 632 )
end

local function AddMagnifyingGlassOptions()

	local info = UIDropDownMenu_CreateInfo()
	UIDropDownMenu_AddSeparator( 1 )
	info.isTitle = true
	info.text = L[ "Long-Forgotten Hippogryph" ]
	info.notCheckable = true
	info.isNotRadio = true
	UIDropDownMenu_AddButton( info, 1 )
	info.isTitle = nil
	info.disabled = nil		
	info.text = L[ "Ephemeral Crystal" ]
	info.func = ToggleCrystals
	info.notCheckable = nil
	info.keepShownOnClick = true
	info.checked = LongForgottenHippogryphDB.hideCrystals == "n"
	info.tooltipTitle = L[ "Ephemeral Crystal" ]
	info.tooltipText = L[ "Show |cFFCA64EFcrystals|r on both the World Map and the Minimap" ]
	info.tooltipOnButton = true
	UIDropDownMenu_AddButton( info, 1 )
	info.text = L[ "Additional Cave Entrances" ]
	info.func = ToggleSpecials
	info.checked = LongForgottenHippogryphDB.hideSpecials == "n"
	info.tooltipTitle = L[ "Additional Cave Entrances" ]
	info.tooltipText = L[ "Show |cFFCA64EFadditional cave entrances|r on both the World Map and the Minimap" ]
	info.tooltipOnButton = true
	UIDropDownMenu_AddButton( info, 1 )
	info.text = L[ "Show Coordinates" ]
	info.func = ToggleCoordinates
	info.checked = LongForgottenHippogryphDB.showCoordinates == "y"
	info.tooltipTitle = L[ "Show Coordinates" ]
	info.tooltipText = L[ "Show |cFFCA64EFcoordinates|r in tooltips for both the World Map and the Minimap" ]
	info.tooltipOnButton = true
	UIDropDownMenu_AddButton( info, 1 )
	info.tooltipTitle = nil
	info.tooltipText = nil
	info.notCheckable = true	
	if ( worldMap.mapAreaLookID >= 630 ) and ( worldMap.mapAreaLookID <= 633 ) then
		info.text = L[ "Reset Pins" ]
		info.func = ResetPins
		info.tooltipTitle = L[ "Reset Pins" ]
		info.tooltipText = L[ "Will be applied to both the World Map and the Minimap.\n"..
							"This effectively erases any changes you made to individual pins" ]
		info.tooltipOnButton = true
		UIDropDownMenu_AddButton( info, 1 )
	end			
	info.tooltipTitle = nil
	info.tooltipText = nil
	info.keepShownOnClick = nil
	if ( worldMap.mapAreaLookID ~= 630 ) then
		info.text = L[ "Go to Azsuna" ]
		info.func = GoToAzsuna
		UIDropDownMenu_AddButton( info, 1 )
	end
	if ( worldMap.mapAreaLookID ~= 632 ) then
		info.text = L[ "Go to Oceanus Cove" ]
		info.func = GoToOceanusCove
		UIDropDownMenu_AddButton( info, 1 )
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		OnEvent Handler
--		===============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local eventFrame = CreateFrame( "Frame" )

local function OnEventHandler( self, event, arg1, ...)

	if event == "ADDON_LOADED" then
	
		if arg1 ~= addonName then return end

		if not LongForgottenHippogryphDB then LongForgottenHippogryphDB = {} end		
		local pinSize = LongForgottenHippogryphDB.pinSize or 25
		local savedE = LongForgottenHippogryphDB.savedE or {}
		local savedC = LongForgottenHippogryphDB.savedC or {}
		local savedO = LongForgottenHippogryphDB.savedO or {}
		local savedS = LongForgottenHippogryphDB.savedS or {}
		local savedU = LongForgottenHippogryphDB.savedU or {}
		local textureE = LongForgottenHippogryphDB.textureE or "1"
		local textureC = LongForgottenHippogryphDB.textureC or "1"
		local textureO = LongForgottenHippogryphDB.textureO or "1"
		local textureS = LongForgottenHippogryphDB.textureS or "1"
		local textureU = LongForgottenHippogryphDB.textureU or "1"
		local hideCrystals = LongForgottenHippogryphDB.hideCrystals or "n"
		local hideSpecials = LongForgottenHippogryphDB.hideSpecials or "n"
		local showCoordinates = LongForgottenHippogryphDB.showCoordinates or "y"
		LongForgottenHippogryphDB = {}
		LongForgottenHippogryphDB.pinSize = pinSize
		LongForgottenHippogryphDB.savedE = savedE
		LongForgottenHippogryphDB.savedC = savedC
		LongForgottenHippogryphDB.savedO = savedO
		LongForgottenHippogryphDB.savedS = savedS
		LongForgottenHippogryphDB.savedU = savedU
		LongForgottenHippogryphDB.textureE = textureE
		LongForgottenHippogryphDB.textureC = textureC
		LongForgottenHippogryphDB.textureO = textureO
		LongForgottenHippogryphDB.textureS = textureS
		LongForgottenHippogryphDB.textureU = textureU
		LongForgottenHippogryphDB.hideCrystals = hideCrystals
		LongForgottenHippogryphDB.hideSpecials = hideSpecials
		LongForgottenHippogryphDB.showCoordinates = showCoordinates
		
		eventFrame:UnregisterEvent( "ADDON_LOADED" )
		
	elseif event == "PLAYER_ENTERING_WORLD" then
	
		for _, overlayFrame in next, WorldMapFrame.overlayFrames do
			if overlayFrame.Border and ( overlayFrame.Border:GetTexture() == "Interface\\Minimap\\MiniMap-TrackingBorder" )  then
				hooksecurefunc( overlayFrame, "InitializeDropDown", AddMagnifyingGlassOptions )
				break
			end
		end
		
		eventFrame:UnregisterEvent( "PLAYER_ENTERING_WORLD" )
	end
end

eventFrame:RegisterEvent( "ADDON_LOADED" )
eventFrame:RegisterEvent( "PLAYER_ENTERING_WORLD" )
eventFrame:SetScript( "OnEvent", OnEventHandler )

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		OnUpdate Handler
--		================
--
--------------------------------------------------------------------------------------------------------------------------------------------

local timeSinceLastUpdate = 0

local function OnUpdateHandler()

	-- From a certain patch/update the timeElapsed was passed as a value. But this block should work across all versions of WoW.
	-- Actually timeElapsed ignores the time elapsed while looking at a loading screen or a cinematic. GetTime is better

	local curTime = GetTime()
	if curTime - timeSinceLastUpdate <= 0.05 then return end
	timeSinceLastUpdate = curTime

	ShowOnMiniMap()		
	ShowOnWorldMap()
	
	if ( mini.mapAreaInID ~= 630 ) and ( mini.mapAreaInID ~= 632 ) then return end		-- Azsuna / Oceanus Cove
		
	local t, mouseOver, scale, cursorX, cursorY, pixels, hypotenuse = "", false;

	for k, v in pairs( tips ) do
		t = ( k == "S" or k == "U" ) and "S" or "E"
		for i = 1, v.num do
		
			if ( mini[ k ][ i ]:IsMouseOver( 0,0,0,0 ) == true ) and ( mini[ k ][ i ]:GetAlpha() == 1 ) then
				mouseOver, mini.tooltipShowing = true, true
			end

			if ( mouseOver == true ) then
		
				GameTooltip:SetOwner( UIParent, "ANCHOR_CURSOR" )
				GameTooltip:SetText( pc_colour_Prefix.. ( ( k == "S" or k == "U" ) and L[ "Cave Entrance" ] 
																					or L[ "Ephemeral Crystal" ] ) )			
				for line in gmatch( ( mini[ k ][ i ].tooltip or "" ), "[^\n]+" ) do
					GameTooltip:AddLine( line )
				end
				if ( LongForgottenHippogryphDB.showCoordinates == "y" ) then
					GameTooltip:AddLine( "(".. format( "%.02f", mini[ k ][ i ].x ).. ",".. 
											format( "%.02f", mini[ k ][ i ].y ).. ")" )
				end
				GameTooltip:Show()
						
				if ( mini.leftMouseUp == true ) then
					if ( worldMap.firstTimeShowing == true ) then
						AssignWorldMapPins()
					end
					local curTexture = tonumber( LongForgottenHippogryphDB[ "saved".. k ][ tostring( i ) ]
														or LongForgottenHippogryphDB[ "texture".. k ] )
					if ( IsShiftKeyDown() == true ) then
						curTexture = ( curTexture <= 1 ) and textures[ t ].num or ( curTexture - 1 )
					else
						curTexture = ( curTexture >= textures[ t ].num ) and 1 or ( curTexture + 1 )
					end
					curTexture = tostring( curTexture )
					LongForgottenHippogryphDB[ "saved".. k ][ tostring( i ) ] = curTexture
					mini[ k ][ i ]:SetTexture( textures[ t ][ curTexture ] )
					mini[ k ][ i ]:SetTexCoord( unpack( textures[ t ].coords[ curTexture ] ) )
					worldMap[ k ][ i ].pinTexture:SetTexture( textures[ t ][ curTexture ] )
					worldMap[ k ][ i ].pinTexture:SetTexCoord( unpack( textures[ t ].coords[ curTexture ] )  )
					mini[ k ][ i ]:SetSize( 0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ curTexture ],
											0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ curTexture ] )
					worldMap[ k ][ i ].pinTexture:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ curTexture ],
															LongForgottenHippogryphDB.pinSize * textures[ t ].size[ curTexture ] )
					worldMap[ k ][ i ]:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ curTexture ],
												LongForgottenHippogryphDB.pinSize * textures[ t ].size[ curTexture ] )
				elseif ( IsControlKeyDown() == true ) then
					local frame = EnumerateFrames()
					local activeChatFrameEditBox;
					while frame do
						if frame:IsVisible() then
							local name = frame:GetName()
							if name and find( name, "ChatFrame(%d+)EditBox" ) then
								activeChatFrameEditBox = frame
								break
							end
						end
						frame = EnumerateFrames( frame )
					end
					if activeChatFrameEditBox then
						local found = false
						if find( activeChatFrameEditBox:GetText(), L[ "Ephemeral Crystal" ] ) then
							found = true
						elseif find( activeChatFrameEditBox:GetText(), L[ "Cave Entrance" ] ) then
							found = true
						end
						if not found then
							activeChatFrameEditBox:Insert( ( ( k == "S" or k == "U" ) and L[ "Cave Entrance" ] 
																						or L[ "Ephemeral Crystal" ] ).. " @ (".. 
								format( "%.02f", mini[ k][ i ].x ).. ",".. format( "%.02f", mini[ k][ i ].y ).. ") ".. " \"".. 
								gsub( mini[ k][ i ].tooltip, "\n", " " ).. "\"" )
						end
					end
				end
				break
			end
		end
		if ( mouseOver == false ) and ( mini.tooltipShowing == true ) then
			GameTooltip:Hide()
			mini.tooltipShowing = false
		end
		if ( mouseOver == true ) then break end
	end
	mini.leftMouseUp = false
end

eventFrame:SetScript( "OnUpdate", OnUpdateHandler )

--------------------------------------------------------------------------------------------------------------------------------------------
--
--		Slash Commands
--		==============
--
--------------------------------------------------------------------------------------------------------------------------------------------

local soundkitHandle = nil

SLASH_LongForgottenHippogryph1, SLASH_LongForgottenHippogryph2, SLASH_LongForgottenHippogryph3 = "/lfh", "/hippo", "/hippogryph"

SlashCmdList[ "LongForgottenHippogryph" ] = function( options )

	local options1, secondParm;
	for v in gmatch( options, "(%S+)" ) do
		v = lower( v )
		if not options1 then
			options1 = sub( v,1,1 )
		else
			secondParm = sub( v,1,2 )
			break
		end
	end

	if not options1 or ( options1 == "?" ) then
		printPC( pc_colour_Highlight.. L[ "Commands" ].. ":\n"..
			pc_colour_Highlight.. "s n".. pc_colour_PlainText.. " = ".. L[ "Pin size" ].. ". ".. L[ "10 to 50" ] )

	elseif ( options1 == "e" ) then
		ToggleCrystals()

	elseif ( options1 == "q" ) then
		ToggleSpecials()

	elseif ( options1 == "c" ) then
		ToggleCoordinates()

	elseif ( options1 == "r" ) then
		ResetPins()

	elseif ( options1 == "s" ) then
		local parm = tonumber( secondParm )
		local changed = false
		if parm then
			if ( parm >= 10 ) and ( parm <= 50 ) then
				local oldValue = LongForgottenHippogryphDB.pinSize
				LongForgottenHippogryphDB.pinSize = parm
				if ( worldMap.firstTimeShowing == true ) then
					AssignWorldMapPins()
				end
				for k, v in pairs( tips ) do
					local t = ( k == "S" or k == "U" ) and "S" or "E"
					for i = 1, v.num do
						local tID = LongForgottenHippogryphDB[ "saved".. k ][ tostring( i ) ] or LongForgottenHippogryphDB[ "texture".. k ]
						worldMap[ k ][ i ].pinTexture:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
																LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
						worldMap[ k ][ i ]:SetSize( LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
													LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
						mini[ k ][ i ]:SetSize( 0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ],
												0.7 * LongForgottenHippogryphDB.pinSize * textures[ t ].size[ tID ] )
					end
				end
				if ( oldValue ~= parm ) then changed = true end
			end
		end
		printPC( pc_colour_Highlight.. "s".. pc_colour_PlainText.. " = ".. pc_colour_Highlight.. LongForgottenHippogryphDB.pinSize )
		if ( changed == false ) then
			printPC( "("..L[ "Default" ].. " = 25)" )
			SlashCmdList[ "LongForgottenHippogryph" ]("")
		end

	-- Easter Eggs. Enjoy!

	elseif ( options1 == "z" ) then
		if ( soundkitHandle ) then
			StopSound( soundkitHandle, 5000 )
			soundkitHandle = nil
		else
			local soundSelection = random( 2 )
			if ( soundSelection == 1 ) then
				_, soundkitHandle = PlaySound( 10896 )		-- Lament of the Highborne
			else
				_, soundkitHandle = PlaySound( 22161 )		-- Vashj'ir
			end
		end
	end
end